<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE Messages [
    <!ELEMENT Messages (Package*)>

    <!ELEMENT Package (Error*)>
    <!ATTLIST Package ID CDATA #REQUIRED>
    <!ATTLIST Package DefaultComponent CDATA #REQUIRED>

    <!ELEMENT Error (#PCDATA)>
    <!ATTLIST Error Key CDATA #REQUIRED>
    <!ATTLIST Error Component CDATA #IMPLIED>
    <!ATTLIST Error NativeErrorCode CDATA #REQUIRED>
    <!ATTLIST Error Params CDATA "0">
]>

<Messages>
    <!-- #################################################################################### -->
    <Package ID="1" DefaultComponent="ODBC">

      <!-- Errors and warnings in general operation. --> 
      <!-- Error thrown when an unexpected exception is caught. --> 
      <Error Key="GenErr" NativeErrorCode="10000">General error: Unexpected exception has been caught.</Error>

      <!-- Same as GenErr, but allows for a custom message (say, from an std::exception) --> 
      <Error Key="GenErr1" Params="1" NativeErrorCode="10001">General error: %1%</Error>

      <!-- Error thrown when a std::bad_alloc exception is caught. --> 
      <Error Key="MemAllocErr" NativeErrorCode="10010">Memory allocation error: std::bad_alloc exception is caught.</Error>

      <!-- Error thrown when ODBC functions are executed out of the allowed sequence as specified in the ODBC specification. --> 
      <Error Key="FuncSeqErr" NativeErrorCode="10020">ODBC Function(s) executed out of allowable sequence.</Error>

      <!-- Error thrown when statement is invalid or not found. --> 
      <Error Key="InvalidStmt" NativeErrorCode="10040">Statement invalid or not found.</Error>

      <!-- Error thrown when connection is invalid or not found. --> 
      <Error Key="InvalidConn" NativeErrorCode="10050">Connection invalid or not found.</Error>

      <!-- Error thrown when descriptor is invalid or not found. --> 
      <Error Key="InvalidAppDesc" NativeErrorCode="10060">Application descriptor invalid or not found.</Error>

      <!-- Error thrown when explicit application descriptor is invalid or not found. --> 
      <Error Key="InvalidExplAppDesc" NativeErrorCode="10070">Explicit application descriptor invalid or not found.</Error>

      <!-- Error thrown when query manager is invalid or not found. --> 
      <Error Key="InvalidQueryMgr" NativeErrorCode="10080">Query manager invalid or not found.</Error>

      <!-- Error thrown when execution results are invalid or not found. --> 
      <Error Key="InvalidExecResults" NativeErrorCode="10090">Execution results invalid or not found.</Error>

      <!-- Errors and warnings with diagnostics reporting. --> 
      <!-- Error thrown when an invalid diagnostic identifier is used. --> 
      <Error Key="InvalidDiagIdent" NativeErrorCode="10110">Invalid diagnostic identifier used.</Error>

      <!-- Error thrown when requesting for a diagnostic field in binary format while no binary diagnostic fields exist. -->
      <Error Key="NoBinaryDiagFields" NativeErrorCode="10120">No binary diagnostic fields exist. Unable to return diagnostic field in binary format.</Error>


      <!-- Errors and warnings with the provided buffer and buffer length. --> 
      <!-- Error thrown when an invalid string or buffer length is provided by the application. --> 
      <Error Key="InvalidStrOrBuffLen" NativeErrorCode="10130">Invalid string or buffer length was provided by the application.</Error>

      <!-- Warning posted when an output string is right truncated to fit into the output buffer. --> 
      <Error Key="StrRightTruncWarn" NativeErrorCode="10160">String data right truncation: String data is too big for the output data buffer and has been truncated.</Error>

      <!-- Error thrown when string data is too big for the driver's data buffer. --> 
      <Error Key="StrRightTruncErr" NativeErrorCode="10170">String data right truncation on data from data source: String data is too big for the driver's data buffer.</Error>

      <!-- Error thrown when an invalid output buffer is provided. --> 
      <Error Key="InvalidOutputBuff" NativeErrorCode="10180">Invalid output buffer provided.</Error>

      <!-- Error thrown when there is an invalid string truncation. --> 
      <Error Key="InvalidStrTrunc" NativeErrorCode="10190">Invalid string truncation.</Error>


      <!-- Error and warnings with Attributes. --> 
      <!-- Error thrown when the attribute type specified is not supported for the current operation. --> 
      <Error Key="AttrTypeNotSupported" NativeErrorCode="10200">Attribute type not supported for current operation.</Error>

      <!-- Error thrown when the attribute identifier specified is invalid or not supported. --> 
      <Error Key="InvalidAttrIdent" Params="1" NativeErrorCode="10210">Attribute identifier invalid or not supported: %1%</Error>

      <!-- Error thrown when setting the value of a read-only attribute. --> 
      <Error Key="CannotSetReadOnlyAttr" NativeErrorCode="10220">Cannot set a read-only attribute.</Error>

      <!-- Error thrown when failed to retrieve an attribute value. --> 
      <Error Key="AttrValNotFound" NativeErrorCode="10230">Cannot obtain attribute value.</Error>

      <!-- Error thrown when setting the implementation descriptor handle, a statement's implementation descriptor cannot be replaced. --> 
      <Error Key="CannotSetImpDescHandle" NativeErrorCode="10240">You cannot change a statement's implementation descriptor handle.</Error>

      <!-- Error thrown when setting the value of SQL_ATTR_ASYNC_ENABLE statement attribute when driver does not support this operation. --> 
      <Error Key="SetAsyncEnabNotSupported" NativeErrorCode="10250">Setting SQL_ATTR_ASYNC_ENABLE attribute not supported.</Error>

      <!-- Error thrown when failed to obtain a connection attribute that is required to check if the current operation is valid. --> 
      <Error Key="ObtainCheckingConnAttrFailed" NativeErrorCode="10260">Could not obtain a required connection attribute to check if current operation is valid.</Error>

      <!-- Error thrown when changing the option to enable auto population of IPD while driver does not support IPD auto population. --> 
      <Error Key="AutoPopIpdNotSupported" NativeErrorCode="10270">Auto population of IPD (Implementation Parameter Descriptor)is not supported.</Error>

      <!-- Error thrown when setting an attribute to a value that is invalid. --> 
      <Error Key="InvalidAttrVal" NativeErrorCode="10280">Invalid attribute value.</Error>

      <!-- Warning posted when setting an attribute value that is not supported or invalid, and the driver was able to substitute a similar value. --> 
      <Error Key="OptAttrValChangedWarn" NativeErrorCode="10290">Attribute value not supported or invalid, so a similar attribute value was substituted. Get the attribute value to see the substitute.</Error>

      <!-- Error thrown when failing to revert a temporarily substituted attribute value back to its original value. --> 
      <Error Key="RevertAttrValueToOrigFailed" NativeErrorCode="10300">Could not revert temporary attribute value back to original value.</Error>

      <!-- Error thrown when failing to obtain a default value for a statement attribute during statement creation. --> 
      <Error Key="ObtainDefaultStmtAttrValueFailed" NativeErrorCode="10310">Could not obtain default statement attribute value.</Error>

      <!-- Error thrown when setting an explicit application descriptor handle on a statement that is not from the statement's parent connection. --> 
      <Error Key="ExplAppDescHandleNotFromSameConn" NativeErrorCode="10320">Explicit application descriptor handle not from the same connection as the target statement.</Error>

      <!-- Error thrown when setting an implicit application descriptor handle on a statement but the descriptor was not one of the target statement's original implicit application descriptors. --> 
      <Error Key="ImplicitAppDescHandleNotOrig" NativeErrorCode="10330">Implicit application descriptor handle is not an original implicit application descriptor of the target statement.</Error>

      <!-- Error and warnings with establishing connection to data source. -->
      <!-- Error thrown when the connection string is not of valid form. -->
      <Error Key="InvalidConnStr" NativeErrorCode="10360">Invalid connection string.</Error>

      <!-- Error thrown when the connection string does not contain information requested by the driver. -->
      <Error Key="InvalidConnStrAttr" NativeErrorCode="10370">Invalid connection string attribute that does not match driver requested information.</Error>

      <!-- Error thrown when unable to establish a connection with the data source. -->
      <Error Key="UnableToEstConn" Params="1" NativeErrorCode="10380">Unable to establish a connection with data source. Missing settings: %1%</Error>

      <!-- Error thrown when failed to obtain connection information through the driver provided dialog box. -->
      <Error Key="UpdateConnSettingsWithDiaglogFailed" NativeErrorCode="10390">Update connection settings with dialog prompt failed.</Error>

      <!-- Error thrown when performing an operation that requires an established connection but no connection has been established yet. -->
      <Error Key="NoEstConn" NativeErrorCode="10400">Current operation requires established connection but no connection has been established yet.</Error>

      <!-- Error thrown when trying to establish a connection but a connection already exist. -->
      <Error Key="ConnAlreadyEst" NativeErrorCode="10410">Connection is already established.</Error>

      <!-- Error thrown when data source did not provide a valid response. -->
      <Error Key="DataSourceDidNotGiveProperResp" NativeErrorCode="10420">Data source did not provide a proper response.</Error>

      <!-- Error thrown when application did not provide enough information to establish a connection to the data source but application specified that driver should not prompt application for more information. -->
      <Error Key="NotEnoughConnInfoButDriverNoPrompt" Params="1" NativeErrorCode="10430">Not enough information provided to establish a connection to the data source and specified to not prompt for more information. Missing required settings: %1%</Error>

      <!-- Error thrown when driver complete flag is invalid or not supported. -->
      <Error Key="InvalidDriverComplFlag" NativeErrorCode="10440">Driver completion flag invalid or not supported.</Error>

      <!-- Error thrown when driver needs an indicator buffer to indicate NULL output data to the application but the application did not provide such buffer. -->
      <Error Key="NullIndPtrNotSupplied" NativeErrorCode="10450">Indicator pointer is required by the driver to indicate NULL output data, but is not provided.</Error>

      <!-- Error thrown when data conversion could not complete properly. -->
      <Error Key="DataConvError" NativeErrorCode="10460">Data conversion error.</Error>

      <!-- Error thrown when data conversion is not supported. -->
      <Error Key="DataConvNotSupported" NativeErrorCode="10470">Data conversion not supported.</Error>

      <!-- Error thrown when fetch orientation is not compatible with current settings. -->
      <Error Key="FetchTypeNotSupported" NativeErrorCode="10480">Fetch type not supported as fetch orientation is not compatible with current settings.</Error>

      <!-- Error thrown when cursor is in an invalid position for fetching data. -->
      <Error Key="InvalidCursorPos" NativeErrorCode="10490">Cursor was either positioned before the beginning or after the end of the result set.</Error>

      <!-- Error thrown when cursor is forward-only and SetPos is called while on a valid row. -->
      <Error Key="InvalidForwardSetPosOper" NativeErrorCode="10495">SQLSetPos is an invalid operation when the cursor is forward-only.</Error>

      <!-- Error thrown when cursor is not of a supported type. -->
      <Error Key="InvalidCursorType" NativeErrorCode="10500">Cursor type invalid or not supported.</Error>

      <!-- Error thrown when cursor is in an invalid state. -->
      <Error Key="InvalidCursorState" NativeErrorCode="10510">Invalid cursor state.</Error>

      <!-- Error thrown when there is no more data left to fetch. -->
      <Error Key="NoMoreDataToFetch" NativeErrorCode="10530">No more data left to fetch.</Error>

      <!-- Error thrown when getting data that has already been fetched, but current settings do not allow this behavior. -->
      <Error Key="NotAllowedToGetSpecifiedColumn" NativeErrorCode="10540">Not allowed to get data for the specified column that was already fetched.</Error>

      <!-- Error thrown when requesting a column in the result set but no matching column is found. -->
      <Error Key="InvalidColNumInResultSet" NativeErrorCode="10550">Invalid result set column number, no matching column found.</Error>

      <!-- Error thrown when checking the status of a fetched row but the status is invalid and not recognized. -->
      <Error Key="InvalidRowStatus" NativeErrorCode="10560">Invalid row status detected after fetching operation.</Error>

      <!-- Error thrown when changing types between multipart SQLGetData() calls. -->
      <Error Key="ChangeTypesInMultipartSQLGetDataNotSupported" NativeErrorCode="10570">Changing types between multipart SQLGetData() calls is not supported.</Error>

      <!-- Error thrown when the source data is invalid (i.e. null when it shouldn't be. -->
      <Error Key="InvalidSrcData" NativeErrorCode="10580">Source data is invalid.</Error>

      <!-- Error thrown when there is no more data to get. -->
      <Error Key="NoMoreDataToGet" NativeErrorCode="10590">There is no more data to get.</Error>

      <!-- Error thrown when the conversion strategy is invalid (i.e. null when it shouldn't be). -->
      <Error Key="InvalidStrategy" NativeErrorCode="10600">Conversion strategy is invalid.</Error>

      <!-- Error thrown when the conversion strategy is not supported. -->
      <Error Key="StrategyNotSupported" NativeErrorCode="10610">Conversion strategy is unsupported.</Error>

      <!-- Error thrown when a conversion is attempted when there is more data. -->
      <Error Key="CannotConvWhileHasMoreData" NativeErrorCode="10620">Cannot convert when there is more data.</Error>

      <!-- Error thrown when the result of a conversion is invalid. -->
      <Error Key="InvalidConvResult" NativeErrorCode="10630">Invalid conversion result.</Error>

      <!-- Error thrown when a flush fails to clear the data. -->
      <Error Key="FlushFailed" NativeErrorCode="10640">Flush failed to clear data.</Error>

      <!-- Error thrown when execution expects a result set but no result set is available from the DSII. -->
      <Error Key="NoAvailableResultSet" NativeErrorCode="10651">No result set is available after execute, but one was available after prepare.</Error>


      <!-- Error and warnings with descriptors. -->
      <!-- Error thrown when requesting a bookmark column but bookmark columns are not supported. -->
      <Error Key="BookmarkColumnNotSupported" NativeErrorCode="10660">Bookmark column not supported.</Error>

      <!-- Error thrown when requesting a descriptor record or its information, but the descriptor record cannot be found -->
      <Error Key="InvalidDescIndex" NativeErrorCode="10670">Invalid descriptor index, descriptor record does not exist, or is not properly initialized.</Error>

      <!-- Error thrown when requesting a descriptor field that is not supported or is invalid. -->
      <Error Key="InvalidDescFieldIdent" NativeErrorCode="10680">Descriptor field identifier invalid or not supported.</Error>

      <!-- Error thrown when descriptor records are not sequential during query execution. -->
      <Error Key="DescRecNotSeq" NativeErrorCode="10690">At least one expected descriptor record does not exist during query execution.</Error>

      <!-- Error thrown when retrieving the SQL_DESC_COUNT field that is zero for a IRD. -->
      <Error Key="InvalidDescCount" NativeErrorCode="10700">Invalid descriptor count field, no count to be returned.</Error>

      <!-- Error thrown when setting a read-only descriptor field. -->
      <Error Key="ReadOnlyDescField" NativeErrorCode="10710">Read only descriptor field.</Error>

      <!-- Error thrown when registering or unregistering a listener (statement) on a non-explicit descriptor. -->
      <Error Key="CannotAssocNonExpDescWithDeleteListener" NativeErrorCode="10720">Cannot associate non-explicit descriptors with descriptor listeners used for deletion cleanup.</Error>

      <!-- Error thrown when getting the parent connection of a non-explicit descriptor. -->
      <Error Key="CannotGetParentConnOnNonExpDesc" NativeErrorCode="10730">Cannot get parent connection on a non-explicit descriptor.</Error>

      <!-- Error thrown when dropping descriptor record of an implementation row descriptor. -->
      <Error Key="CannotDropRecOfImplRowDesc" NativeErrorCode="10740">Cannot drop record of an implementation row descriptor.</Error>

      <!-- Error thrown when an invalid or not supported datetime subcode identifier is given. -->
      <Error Key="InvalidDatetimeSubcodeIdent" NativeErrorCode="10750">Datetime subcode identifier invalid or not supported.</Error>

      <!-- Error thrown when an invalid or not supported interval subcode identifier is given. -->
      <Error Key="InvalidIntevalSubcodeIdent" NativeErrorCode="10760">Interval subcode identifier invalid or not supported.</Error>

      <!-- Error thrown when requesting a descriptor field that is not supported or invalid. -->
      <Error Key="DescFieldNotSupported" NativeErrorCode="10770">Descriptor field invalid or not supported.</Error>

      <!-- Error thrown when using a non-string method to get a string descriptor field. -->
      <Error Key="CannotGetStrDescFieldInNonStrMethod" NativeErrorCode="10780">Invalid use of non-string method to get string descriptor field.</Error>

      <!-- Error thrown when specifying a descriptor field type that is not valid or not supported -->
      <Error Key="InvalidDescFieldType" NativeErrorCode="10790">Descriptor field type invalid or not supported.</Error>

      <!-- Error thrown when the specified descriptor record cannot be found. -->
      <Error Key="DescRecNotFound" NativeErrorCode="10800">Descriptor record not found.</Error>

      <!-- Error thrown when setting SQL_DESC_UNNAMED to SQL_NAMED which is not allowed. -->
      <Error Key="DescUnnamedNotAllowed" NativeErrorCode="10810">Not allowed to set SQL_DESC_UNNAMED to SQL_NAMED.</Error>

      <!-- Error thrown when performing an operation which requires the statement to be prepared but is not. -->
      <Error Key="StmtNotPrep" NativeErrorCode="10820">Statement is not prepared.</Error>

      <!-- Error thrown when setting or getting a descriptor field value that is not supported. -->
      <Error Key="DescFieldValueNotSupported" Params="2" NativeErrorCode="10830">Descriptor field %1% does not support the value %2%.</Error>

      <!-- Error thrown when application modifies an implementation row descriptor -->
      <Error Key="CannotModImpRowDesc" NativeErrorCode="10840">Cannot modify implementation row descriptors.</Error>

      <!-- Error thrown when setting the SQL_DESC_ALLOC_TYPE descriptor field. -->
      <Error Key="CannotSetDescAllocType" NativeErrorCode="10850">Cannot set descriptor SQL_DESC_ALLOC_TYPE.</Error>

      <!-- Error thrown when an illegal descriptor type is detected. -->
      <Error Key="IllegalDescType" NativeErrorCode="10860">Illegal descriptor type is detected.</Error>

      <!-- Error thrown when an illegal descriptor concise type is detected -->
      <Error Key="IllegalDescConciseType" NativeErrorCode="10870">Illegal descriptor concise type.</Error>

      <!-- Error thrown when an invalid or not supported datetime interval code is given. -->
      <Error Key="InvalidDatetimeCodeIdent" NativeErrorCode="10880">Datetime interval code invalid or not supported.</Error>

      <!-- Error thrown when an invalid or not supported interval code is given. -->
      <Error Key="InvalidIntervalCode" NativeErrorCode="10890">Interval code invalid or not supported.</Error>


      <!-- Error and warnings with SQL statement execution. -->
      <!-- Error thrown when reading from an output parameter. -->
      <Error Key="CannotReadFromOutputParam" NativeErrorCode="10900">Cannot read from output parameter.</Error>

      <!-- Error thrown when reading from a default input parameter. -->
      <Error Key="CannotReadFromDefaultParam" NativeErrorCode="10910">No data can be obtained from default input parameter.</Error>

      <!-- Error thrown when reading from an input parameter which value has already been pushed down. -->
      <Error Key="CannotReadFromPushedParam" NativeErrorCode="10920">No data can be obtained from input parameter whose value has already been pushed down.</Error>

      <!-- Error thrown when writing to a default output parameter. -->
      <Error Key="WriteToDefaultParam" NativeErrorCode="10930">Cannot write to a default parameter.</Error>

      <!-- Error thrown when writing to an input parameter -->
      <Error Key="WriteToInputParam" NativeErrorCode="10940">Cannot write to an input parameter.</Error>

      <!-- Error thrown when received an execute result status code that is not recognizable. -->
      <Error Key="InvalidExecStatusCode" NativeErrorCode="10950">Execute result status code is invalid or not supported.</Error>

      <!-- Error thrown when sending concatenated data that is not binary nor character. -->
      <Error Key="SendNonCharBinaryConcatData" NativeErrorCode="10970">Cannot concatenate and send data that is not character or binary.</Error>

      <!-- Error thrown when sending concatenated data that is a default or null parameter. -->
      <Error Key="SendConcatDataForDefaultOrNullParam" NativeErrorCode="10980">Cannot concatenate and send data in pieces for default for null parameter.</Error>

      <!-- Error thrown when getting SQLGetInfo field which is not supported. -->
      <Error Key="InvalidGetInfoField" NativeErrorCode="10990">SQLGetInfo field is invalid or not supported.</Error>

      <!-- Error thrown when getting query executor from catalog query manager.  Catalog functions are already executed thus has not query executor. -->
      <Error Key="NoQueryExecutor" NativeErrorCode="11000">No query executor exists for catalog query manager.</Error>

      <!-- Error thrown when there is no data-at-execution parameter detected for query executor. -->
      <Error Key="NoDataAtExecParameter" NativeErrorCode="11010">No data-at-execution parameter.</Error>

      <!-- Error thrown when querying a parameter source during auto population. -->
      <Error Key="CannotQueryParmSrcDuringPopulate" NativeErrorCode="11020">Cannot query information about parameter source during parameter auto population.</Error>

      <!-- Error thrown when setting fields of a parameter source during parameter data pushing. -->
      <Error Key="CannotSetParmSrcAttrDuringPushData" NativeErrorCode="11030">Cannot set parameter source attributes during parameter data pushing.</Error>

      <!-- Error thrown when querying push value status while not performing execution.  -->
      <Error Key="PushValueStatusUnknown" NativeErrorCode="11040">Push value status can only be queried during execution.</Error>

      <!-- Error thrown when registering a parameter but not allowed in current state of execution. -->
      <Error Key="ParamRegistNotPermit" NativeErrorCode="11050">Parameter registration not permitted.</Error>

      <!-- Error thrown when invalid parameter index used for parameter registration. -->
      <Error Key="InvalidParamRegistIndex" NativeErrorCode="11060">Invalid parameter index used for registration.</Error>

      <!-- Error thrown when descriptor field value is not recognizable. -->
      <Error Key="DescFieldNotRecg" NativeErrorCode="11070">Descriptor field value not of recognized value.</Error>

      <!-- Error thrown when parameter type is invalid or not supported  -->
      <Error Key="InvalidParameterType" NativeErrorCode="11080">Parameter type invalid or not supported.</Error>


      <!-- Error and warnings with connection and statement. -->
      <!-- Error thrown when setting a cursor name that is longer than the maximum limit. -->
      <Error Key="CursorNameTooLong" NativeErrorCode="11100">Cursor name too long.</Error>

      <!-- Error thrown when setting a cursor name that is already in use. -->
      <Error Key="DuplicateCursorName" NativeErrorCode="11110">Duplicate cursor name.</Error>

      <!-- Error thrown when there are outstanding transactions when attempting to disconnect. -->
      <Error Key="OutstandingTransDuringDisconn" NativeErrorCode="11120">Outstanding transactions during disconnect.</Error>

      <!-- Error thrown when using a connection to allocate a resource that is not statement nor descriptor. -->
      <Error Key="AllocNonStmtDescInConn" NativeErrorCode="11130">Cannot use a connection to allocate a non-statement and non-descriptor resource.</Error>

      <!-- Error thrown when using a connection to free a resource that is not statement nor descriptor. -->
      <Error Key="FreeNonStmtDescInConn" NativeErrorCode="11140">Cannot use a connection to free a non-statement and non-descriptor resource.</Error>

      <!-- Error thrown when freeing an implicit application descriptor. -->
      <Error Key="FreeImplicitAppDesc" NativeErrorCode="11150">Cannot free an implicit application descriptor.</Error>

      <!-- Error thrown when dropping an implicit application descriptor from its parent statement. -->
      <Error Key="DropImplicitAppDesc" NativeErrorCode="11160">Cannot drop implicit application descriptor from its parent statement.</Error>

      <!-- MAINTENANCE NOTE: This error message needs to manually be duplicated in the other locales, since it has not be translated -->
      <!-- Error thrown when cannot retrieve the requested SQLGetInfo property.  -->
      <Error Key="GetInfoPropNotFound" NativeErrorCode="11180" Params="1">SQLGetInfo property not found: %1%</Error>

      <!-- Error thrown when freeing a statement when no statements have been allocated. -->
      <Error Key="FreeStmtWithoutAllocStmt" NativeErrorCode="11190">Cannot free a statement without an allocated statement.</Error>

      <!-- Error thrown when setting an attribute that is not allowed to be set in the current state of execution. -->
      <Error Key="AttrCantBeSetNow" NativeErrorCode="11200">Attribute cannot be set now.</Error>

      <!-- Error thrown when performing an operation that is not allowed during a transaction state. -->
      <Error Key="InvalidTransState" NativeErrorCode="11210">Invalid transaction state: Operation not allowed during the transaction state.</Error>

      <!-- Error thrown when the current operation requires a cursor spec but statement does not have one. -->
      <Error Key="PreparedStmtNotCursorSpec" NativeErrorCode="11220">Prepared statement is not a cursor specification.</Error>

      <!-- Warning posted when SQLCancel is treated as closing a cursor. -->
      <Error Key="CancelTreatedAsCloseWarn" NativeErrorCode="11230">Cancel treated as close cursor.</Error>

      <!-- Error thrown when free statement option identifier is invalid or not supported. -->
      <Error Key="InvalidFreeStmtOptionIdent" NativeErrorCode="11240">Free statement option identifier invalid or not supported.</Error>

      <!-- Error thrown when column attribute field identifier is invalid or not supported. -->
      <Error Key="InvalidColAttrFieldIdent" NativeErrorCode="11250">Column attribute field identifier invalid or not supported.</Error>

      <!-- Error thrown when the result type of a statement is invalid or not supported. -->
      <Error Key="InvalidStmtResultType" NativeErrorCode="11270">Statement result type invalid or not supported.</Error>

      <!-- Error thrown when the setting the current catalog when a result set is pending. -->
      <Error Key="InvalidCursorStateSetCatalog" NativeErrorCode="11280">Invalid cursor state. Cannot set current catalog when results are pending.</Error>


      <!-- Error and warnings with environment. -->
      <!-- Error thrown when using an environment to allocate a resource that is not connection. -->
      <Error Key="AllocNonConnInEnv" NativeErrorCode="11290">Cannot use an environment to allocate a non-connection resource.</Error>

      <!-- Error thrown when using an environment to free a resource that is not connection. -->
      <Error Key="InvalidFreeHandleOperationInEnvAllocState" NativeErrorCode="11300">Invalid free handle operation in the allocated environment state.</Error>

      <!-- Error thrown when SQL C type is not supported. -->
      <Error Key="SqlCTypeNotSupported" NativeErrorCode="11310">SQL C type not supported.</Error>

      <!-- Error thrown when SQL type is not supported. -->
      <Error Key="SqlTypeNotSupported" NativeErrorCode="11320">SQL type not supported.</Error>

      <!-- Error thrown when setting a cursor name that begins with the reserved prefix. -->
      <Error Key="CursorNameBeginWithReservedPrefix" NativeErrorCode="11330">Cursor name cannot begin with reserved prefix.</Error>


      <!-- Error and warnings with catalog functions. -->
      <!-- Error thrown when fail to map metadata table id to catalog function id. -->
      <Error Key="MetadataTableIDNotFoundForCatalogFunctionId" NativeErrorCode="11360">Cannot find metadata table ID corresponding to the catalog function ID.</Error>

      <!-- Error thrown when catalog name is null but is required. -->
      <Error Key="InvalidNullCatalogName" NativeErrorCode="11370">Invalid use of NULL pointer for catalog name.</Error>

      <!-- Error thrown when schema name is null but is required. -->
      <Error Key="InvalidNullSchemaName" NativeErrorCode="11371">Invalid use of NULL pointer for schema name.</Error>

      <!-- Error thrown when table name is null but is required. -->
      <Error Key="InvalidNullTableName" NativeErrorCode="11375">Invalid use of NULL pointer for table name.</Error>

      <!-- Error thrown when column name is null but is required. -->
      <Error Key="InvalidNullColumnName" NativeErrorCode="11376">Invalid use of NULL pointer for column name.</Error>

      <!-- Error thrown when procedure name is null but is required. -->
      <Error Key="InvalidNullProcName" NativeErrorCode="11377">Invalid use of NULL pointer for procedure name.</Error>

      <!-- Error thrown when catalog name longer than max. -->
      <Error Key="CatalogNameTooLong" NativeErrorCode="11380">Catalog name too long.</Error>

      <!-- Error thrown when schema name longer than max. -->
      <Error Key="SchemaNameTooLong" NativeErrorCode="11390">Schema name too long.</Error>

      <!-- Error thrown when table name longer than max. -->
      <Error Key="TableNameTooLong" NativeErrorCode="11400">Table name too long.</Error>

      <!-- Error thrown when procedure name longer than max. -->
      <Error Key="ProcNameTooLong" NativeErrorCode="11410">Procedure name too long.</Error>

      <!-- Error thrown when column name longer than max. -->
      <Error Key="ColumnNameTooLong" NativeErrorCode="11420">Column name too long.</Error>

      <!-- Error thrown when provided a catalog name but catalog names are not supported. -->
      <Error Key="CatalogNameNotSupported" NativeErrorCode="11430">Catalog name not supported.</Error>

      <!-- Error thrown when provided a schema name but schemas are not supported. -->
      <Error Key="SchemaNotSupported" NativeErrorCode="11440">Schema not supported.</Error>

      <!-- Error thrown when the current settings of bookmark and cursor type are not compatible. -->
      <Error Key="BookmarkNotSupportedForCursorType" NativeErrorCode="11450">Bookmark not supported for cursor type.</Error>

      <!-- Error thrown when catalog function id is invalid or not supported. -->
      <Error Key="InvalidCatalogFuncID" NativeErrorCode="11460">Catalog function ID invalid not supported.</Error>

      <!-- Error thrown when attempting to use transactions when they aren't supported. -->
      <Error Key="TransNotSupported" NativeErrorCode="11470">Transactions are not supported.</Error>

      <!-- Error and warnings with driver functions. -->
      <!-- Error thrown when we have too many handles. -->
      <Error Key="TooManyHandles" NativeErrorCode="11480">Too many handles. Free handles to generate more.</Error>

      <!-- Error thrown when an operation is canceled. -->
      <Error Key="OperationCanceled" NativeErrorCode="11490">Operation canceled.</Error>


      <!-- Error and warnings with driver functions. -->
      <!-- Error thrown when driver configuration is invalid for DriverManagerEncoding -->
      <Error Key="DriverConfigurationWarningEncoding" NativeErrorCode="11510">Invalid driver configuration for DriverManagerEncoding.</Error>

      <!-- Error thrown when unable to use SQLGetPrivateProfileString functions. -->
      <Error Key="NoSQLGetPrivateProfileString" NativeErrorCode="11560">Unable to locate SQLGetPrivateProfileString function.</Error>

      <!-- Error thown when attempting to connect with missing required credential settings. -->
      <Error Key="CredentialMissing" NativeErrorCode="11570" Params="1">Required credential settings are missing: %1%. </Error>
    </Package>
    
    <!-- #################################################################################### -->
    <Package ID="2" DefaultComponent="DSI">

      <!-- Error thrown when fail to get connection property from DSI  -->
      <Error Key="DSIConnPropNotFound" Params="1" NativeErrorCode="20000">Connection property not found in DSI: %1%</Error>

      <!-- Error thrown when fail to get driver property from DSI. -->
      <Error Key="DSIDriverPropNotFound" Params="1" NativeErrorCode="20001">Driver property not found in DSI: %1%</Error>

      <!-- Error thrown when fail to get environment property from DSI. -->
      <Error Key="DSIEnvPropNotFound" Params="1" NativeErrorCode="20002">Environment property not found in DSI: %1%</Error>

      <!-- Error thrown when fail to get statement property from DSI. -->
      <Error Key="DSIStmtPropNotFound" Params="1" NativeErrorCode="20003">Statement property not found in DSI: %1%</Error>

      <!-- Error thrown when setting driver to not put null terminator while driver does not support this feature. -->
      <Error Key="EnvAttrOutputNtsNotSupported" NativeErrorCode="20004">Driver does not support returning non null-terminated strings.</Error>

      <!-- Error thrown when fail to get statement property limits. -->
      <Error Key="DSIStmtPropLimitNotFound" Params="1" NativeErrorCode="20005">Statement property limitation not found: %1%</Error>

      <!-- Error thrown when current result set traversal direction is not supported. -->
      <Error Key="ResultSetTraverseDirNotSupported" Params="1" NativeErrorCode="20006">Result set traversal direction is not supported: %1%</Error>

      <!-- Error thrown when metadata table id is invalid or not supported. -->
      <Error Key="InvalidMetadataTableID" Params="1" NativeErrorCode="20007">Invalid metadata table ID: %1%</Error>

      <!-- Error thrown when invalid filter is passed into metadata restriction generator. -->
      <Error Key="InvalidFilterInMetadataRestrictionGenerator" NativeErrorCode="20008">Invalid filter being used in metadata restriction generator.</Error>

      <!-- Error thrown when no columns are marked as needed during data retrieval. -->
      <Error Key="NoColumnsNeededDuringDataRetrieval" NativeErrorCode="20012">No column data requested but data retrieval performed.</Error>

      <!-- Error thrown when no column exists for column number for data retrieval. -->
      <Error Key="InvalidColumnNum" Params="1" NativeErrorCode="20013">Invalid column number: %1%</Error>

      <!-- Error thrown when metadata source invalid or not found. -->
      <Error Key="MetadataSourceNotFound" NativeErrorCode="20014">Metadata source invalid or not found.</Error>

      <!-- Error thrown when cursor type invalid or not supported. -->
      <Error Key="CursorTypeNotSupported" Params="1" NativeErrorCode="20016">Cursor type is not supported: %1%</Error>

      <!-- Error thrown when asking basic metadata result for derived data. -->
      <Error Key="CannotGetDerivedDataOnBasicResult" NativeErrorCode="20017">Cannot retrieve derived data on basic filtered metadata result.</Error>

      <!-- Error thrown when derived column Id is invalid for current metadata root. -->
      <Error Key="InvalidDerivedColumnID" NativeErrorCode="20018">Invalid derived metadata column ID.</Error>

      <!-- Error thrown when current parameter is default but data source does not allow it to be default value for current parameter. -->
      <Error Key="DefaultParamNotAllowed" NativeErrorCode="20020">Current parameter has no default value and is not allowed to be default.</Error>

      <!-- Error thrown when a specified column name is invalid or not found. -->
      <Error Key="InvalidColumnName" Params="1" NativeErrorCode="20021">Invalid column name: %1%</Error>

      <!-- Error thrown when there is an invalid filter value (i.e. null). -->
      <Error Key="InvalidFilterVal" NativeErrorCode="20023">Invalid filter value - do not use null strings in filter values, to do no filtering use an empty vector.</Error>
      
      <!-- Error thrown when performing cursor or data retrieval related operations on a row count result. -->
      <Error Key="CannotPerformCursorOrDataRetrievalOperationOnRowCountResult" NativeErrorCode="20027">Cannot perform cursor or data retrieval related operations on row count result.</Error>
      
      <!-- Error thrown when a function is not supported. -->
      <Error Key="FuncNotSupported" NativeErrorCode="20029">Function not supported.</Error>
      
      <!-- Error thrown when memory allocation failed. -->
      <Error Key="DSIMemAllocErr" NativeErrorCode="20030">Memory management error.</Error>

      <!-- Error thrown when cannot find custom property. -->
      <Error Key="CustomPropNotFound" Params="1" NativeErrorCode="20031">Custom property not found: %1%</Error>

      <!-- Error thrown when a required setting is requested but not present. -->
      <Error Key="DSIReqSettingNotFound" Params="1" NativeErrorCode="20032">Required setting '%1%' is not present in the connection settings.</Error>

      <!-- Error thrown when a parameter type is output for an input parameter, or input for an output parameter. -->
      <Error Key="IncompatibleParameterTypes" Params="1" NativeErrorCode="20033">Incompatible parameter type specified for parameter: %1%.</Error>

      <!-- Error thrown when a parameter SQL type doesn't match the bound type. -->
      <Error Key="IncompatibleParameterSqlTypes" Params="3" NativeErrorCode="20034">Incompatible parameter SQL type specified for parameter: %1%. Bound type: %2%. Expected type: %3%</Error>

      <!-- Error thrown when a specifying an invalid catalog as the current catalog. -->
      <Error Key="InvalidCurrentCatalog" Params="1" NativeErrorCode="20035">Invalid catalog specified: %1%</Error>

      <!-- Error thrown when a hex string with an odd length is given to DSITypeUtilities::HexStringToBinary() -->
      <Error Key="DSIHexToBinaryConversionOddLengthError" NativeErrorCode="20036">There was an error converting from a hexidecimal string to binary: The given hexadecimal string was of an odd length.</Error>

      <!-- Error thrown when a hex string with an invalid character is given to DSITypeUtilities::HexStringToBinary() -->
      <Error Key="DSIHexToBinaryConversionInvalidCharacterError" Params="1" NativeErrorCode="20037">There was an error converting from a Hexidecimal string to binary: The given hex string contained the non-hex character '%1%'.</Error>

      <!-- Error thrown when an property type is incorrect. -->
      <Error Key="IncorrectPropertyAttributeType" Params="3" NativeErrorCode="20038">Property AttributeData type is incorrect for property key %1%. Expected: %2%, Actual: %3%</Error>
      
      <!-- Error thrown when an ICU throws a U_FAILURE. -->
      <Error Key="ICUUFailureStatus" Params="3" NativeErrorCode="20039">There was an error when initializing an ICU function, %1%, with the following UErrorCode, %2%.</Error>

      <!-- Error thrown when the total swap file disk space has reached the limit. -->
      <Error Key="SwapLimitErr" NativeErrorCode="20040">Total swap files disk space limit reached.</Error>
    
      <!-- Error thrown when OpenSSL fails to load. -->
      <Error Key="LibLoadErr" NativeErrorCode="20041">There was an error while loading the dynamic or shared library '%1%': '%2%'.</Error>
    
      <!-- Error thrown when OpenSSL fails to load. -->
      <Error Key="LibFunctLoadErr" NativeErrorCode="20042">There was an error while loading the function '%2%' from the dynamic or shared library '%1%'.</Error>
    
      <!-- Error thrown when OpenSSL fails to load. -->
      <Error Key="SwapFileEncryptErr" NativeErrorCode="20043">There was an internal error while encrypting or decrypting the content of a swap file: Call '%1%' - reason '%2%'.</Error>
    
      <!-- Swap: Read error. -->
      <Error Key="SwapReadError" NativeErrorCode="20044">Internal error - SwapReadError.</Error>

      <!-- Swap: Seek error. -->
      <Error Key="SwapSeekError" NativeErrorCode="20045">Internal error - SwapSeekError.</Error>

	    <!-- Swap: Write error. -->
      <Error Key="SwapWriteError" Params="1" NativeErrorCode="20046">Error in writing to the temporary swap file %1%. Please check that the swap file location is both writeable and has sufficient space - SwapWriteError</Error>
      
	  <!-- [HY000]: Invalid argument passed to a function. -->
      <Error Key="InvalidArgument" Params="2" NativeErrorCode="21000">Invalid argument(s) passed into a function [%1%: %2%].</Error>

      <!-- [HY000]: Invalid function/method has been invoked. -->
      <Error Key="InvalidOperation" Params="3" NativeErrorCode="21001">A logic error occurred while calling function %1% [%2%: %3%]. Ensure the operation is supported and the function is implemented.</Error>
	  
      <!-- [22019]: Invalid LIKE escape character. -->
      <Error Key="InvalidEscapeChar" Params="1" NativeErrorCode="22019">Invalid LIKE ESCAPE clause '%1%'. It must consist of exactly 1 character.</Error>

      <!-- [22025]: Invalid LIKE escape sequence. -->
      <Error Key="InvalidEscapeSequence" NativeErrorCode="22025">Invalid LIKE ESCAPE sequence. Escape character must be followed be a '%', '_', or another escape character.</Error>

    </Package>

    <!-- #################################################################################### -->
    <Package ID="3" DefaultComponent="Support">

      <!-- Error thrown when attribute data type is invalid or not supported. -->
      <Error Key="AttrDataTypeNotRecog" NativeErrorCode="40020">Attribute data type not recognized.</Error>

      <!-- Error thrown when buffer is too small to hold binary attribute data. --> 
      <Error Key="BufLenTooSmallForBinaryAttrData" NativeErrorCode="40070">Buffer length too small for the returning binary attribute data.</Error>

      <!-- Error thrown when warning listener is not valid or not found. --> 
      <Error Key="WarningListenerNotValid" NativeErrorCode="40090">Warning listener is not valid.</Error>

      <!-- Error thrown when invalid string buffer length is given. --> 
      <Error Key="InvalidStrBufLen" NativeErrorCode="40100">Invalid string buffer length.</Error>

      <!-- Error thrown when converting from SQL C type to SQL C type. --> 
      <Error Key="IllegalDataConvFromCToCType" NativeErrorCode="40110">Illegal data conversion from SQL C type to SQL C type.</Error>

      <!-- Error thrown when converting from SQL type to SQL type. --> 
      <Error Key="IllegalDataConvFromSQLToSQLType" NativeErrorCode="40120">Illegal data conversion from SQL type to SQL type.</Error>

      <!-- Error thrown when setting precision less than zero. --> 
      <Error Key="PrecLessThanZero" NativeErrorCode="40130">Precision can't be less than zero.</Error>

      <!-- Error thrown when setting precision greater than supported. -->
      <Error Key="MaxPrecisionExceeded" Params="2" NativeErrorCode="40131">The number '%1%' exceeds the maximum precision allowed (%2%).</Error>

      <!-- Error thrown when setting scale less than zero. --> 
      <Error Key="ScaleLessThanZero" NativeErrorCode="40140">Scale can't be less than zero.</Error>

      <!-- Error thrown when SQL C type is not supported. --> 
      <Error Key="SQLCTypeNotSupported" Params="2" NativeErrorCode="40150">SQL C type not supported: %1% (%2%)</Error>

      <!-- Error thrown when SQL type is not supported. --> 
      <Error Key="SQLTypeNotSupported" Params="2" NativeErrorCode="40160">SQL type not supported: %1% (%2%)</Error>

      <!-- Error thrown when SQL TDW type is not supported. --> 
      <Error Key="SQLTDWTypeNotSupported" Params="1" NativeErrorCode="40170">SQL TDW type not supported (%1%).</Error>

      <!-- Error thrown when data conversion algorithm resulted in an error. -->
      <Error Key="DataConvAlgorithmError" NativeErrorCode="40180">Data conversion algorithm error.</Error>

      <!-- Error thrown when data conversion algorithm resulted in a memory allocation error. -->
      <Error Key="DataConvAlgorithmMemError" NativeErrorCode="40181">Data conversion algorithm memory allocation error.</Error>

      <!-- Error thrown when conversion between the 2 data types are not supported. --> 
      <Error Key="DataConvAlgorithmNotSupported" Params="2" NativeErrorCode="40190">Data conversion algorithm not supported for %1% to %2%.</Error>

      <!-- Error thrown when fail to map SQLC type to tDW type. -->
      <Error Key="TDWTypeNotFoundForCType" Params="2" NativeErrorCode="40450">Cannot find a corresponding TDW type for the SQL C type %1% (%2%).</Error>

      <!-- Error thrown when fail to map SQL type to tDW type. -->
      <Error Key="TDWTypeNotFoundForSqlType" Params="2" NativeErrorCode="40460">Cannot find a corresponding TDW type for a SQL type %1% (%2%).</Error>

      <!-- Error thrown when fail to find default SQL C type for the TDW type. --> 
      <Error Key="DefaultCForTDWTypeNotFound" Params="2" NativeErrorCode="40210">Cannot find a default SQL C type for the TDW type %1% (%2%).</Error>

      <!-- Error thrown when TDW timestamp type is invalid. --> 
      <Error Key="InvalidTDWTimestampType" NativeErrorCode="40220">Invalid TDW timestamp type.</Error>

      <!-- Error thrown when joining two buffer descriptors forms a loop. -->
      <Error Key="DetectedBufferDescriptorLoop" NativeErrorCode="40240">Detected a loop when joining two buffer descriptors.</Error>

      <!-- Error thrown when attempting to allocate memory for a string fails. -->
      <Error Key="CannotAllocateMemoryForString" NativeErrorCode="40250">Cannot allocate memory to read string into.</Error>

      <!-- Error thrown when attempting to generate a new handle when the maximum handle value has been hit. -->
      <Error Key="CannotGenerateHandle" NativeErrorCode="40260">Too many handles. Free handles to generate more.</Error>

      <!-- Error thrown when an argument is passed to an object that is invalid. -->
      <Error Key="IllegalArgument" NativeErrorCode="40280">Invalid argument passed to function.</Error>

      <!-- Error thrown when a new handle failed to be inserted in the manager. -->
      <Error Key="HandleInsertionFailed" NativeErrorCode="40290">Handle was not successfully inserted into handle manager.</Error>

      <!-- Warning posted when trying to get attribute data as the wrong type. -->
      <Error Key="BadAttrType" NativeErrorCode="40300">Cannot get attribute as requested type.</Error>

      <!-- Error thrown when SetLength or AttachBuffer are called on SQLData with the wrong ownership strategy. -->
      <Error Key="InvalidBufferStrategyOperation" NativeErrorCode="40310">Invalid opperation for the selected buffer ownership strategy.</Error>

      <!-- Error posted when an arithmetic operation resulted in an invalid numeric. -->
      <Error Key="TDWNumericArithmeticError" Params="1" NativeErrorCode="40320">Numeric operation '%1%' resulted in an invalid numeric.</Error>

      <!-- Error thrown when constructing a numeric from a string resulted in an invalid numeric. -->
      <Error Key="TDWNumericStringError" Params="1" NativeErrorCode="40321">String value '%1%' resulted in an invalid numeric.</Error>

      <!-- Error thrown when constructing a numeric from a number resulted in an invalid numeric. -->
      <Error Key="TDWNumericValueError" Params="1" NativeErrorCode="40322">Value '%1%' resulted in an invalid numeric.</Error>

      <!-- Error thrown when constructing a numeric from a number resulted in an invalid numeric. -->
      <Error Key="TDWNumericOperationOnInvalid" Params="1" NativeErrorCode="40323">Attempted operation '%1%' on an invalid numeric.</Error>

      <!-- Error thrown when fetching a numeric resulted in an out of range error. -->
      <Error Key="TDWNumericOutOfRangeError" Params="2" NativeErrorCode="40324">Value '%1%' fetched as %2% was out of range.</Error>

      <!-- Swap: Invalid column number. -->
      <Error Key="SwapInvalidColumnNum" NativeErrorCode="40340">Internal error - SwapInvalidRowColumnNum.</Error>

      <!-- Swap: Invalid offset. -->
      <Error Key="SwapInvalidOffset" NativeErrorCode="40350">Internal error - SwapInvalidOffset.</Error>

      <!-- Swap: Invalid row number. -->
      <Error Key="SwapInvalidRowNum" NativeErrorCode="40360">Internal error - SwapInvalidRowNum.</Error>

      <!-- Error thrown when the end of the message buffer is encountered while more data is expected. -->
      <Error Key="UnexpectedBufferEnd" NativeErrorCode="40400">Unexpectedly reached the end of content buffer.</Error>

      <!-- Error thrown if the serializer runs out of memory to serialize into. -->
      <Error Key="OutOfMemToSerialize" NativeErrorCode="40410">Ran out of memory to serialize content into.</Error>

      <!-- Error thrown when traversal direction is not supported for temporary table. -->
      <Error Key="TempTableTraverseDirNotSupported" NativeErrorCode="40430">Traversal direction is not supported for temporary table.</Error>

      <!-- Error thrown when accesing a closed temporary table. -->
      <Error Key="CannotAccessDataWithCursor" NativeErrorCode="40440">Cannot access data in temporary table without open cursor.</Error>

      <!-- [01004]: String data, right-truncated. -->
      <Error Key="StrRightTrunc" NativeErrorCode="40450">String data truncated while performing conversion.</Error>

      <!-- [01S07]: Fractional truncation. -->
      <Error Key="FractionalTrunc" NativeErrorCode="40460">Fractional data truncated while performing conversion.</Error>

      <!-- [07006]: Restricted data type violation. -->
      <Error Key="RestrictedDataTypeAttrViolation" NativeErrorCode="40461">Restricted data type attribute violation.</Error>

      <!-- [07006]: Invalid multi-field interval conversion. -->
      <Error Key="InvalidMultiFieldIntervalConversion" NativeErrorCode="40462">Invalid conversion. Multi-field intervals can't be converted to a single number.</Error>

      <!-- [22001]: String data, right-truncated. -->
      <Error Key="StrRightTruncErr" NativeErrorCode="40465">String data truncated while performing conversion.</Error>

      <!-- [22003]: Numeric value out of range. -->
      <Error Key="NumericValOutOfRange" Params="2" NativeErrorCode="40470">Conversion error at column %1% and row %2%: Numeric value out of range.</Error>

      <!-- [22007]: Invalid date, time or datetime format. -->
      <Error Key="InvalidDatetimeFormat" NativeErrorCode="40480">Invalid date, time or timestamp format.</Error>

      <!-- [22007]: Invalid date format. -->
      <Error Key="InvalidDateFormat" Params="1" NativeErrorCode="40481">Invalid date format for '%1%'. The format should be [-]YYYY-MM-DD.</Error>

      <!-- [22007]: Invalid time format. -->
      <Error Key="InvalidTimeFormat" Params="1" NativeErrorCode="40482">Invalid time format for '%1%'. The format should be hh:mm:ss[.fffffffff].</Error>

      <!-- [22007]: Invalid timestamp format. -->
      <Error Key="InvalidTimestampFormat" Params="1" NativeErrorCode="40483">Invalid timestamp format for '%1%'. The format should be [-]YYYY-MM-DD hh:mm:ss[.fffffffff].</Error>

      <!-- [22007]: Invalid date, time or datetime value. -->
      <Error Key="InvalidDatetimeValue" NativeErrorCode="40490">Invalid date, time or timestamp value.</Error>

      <!-- [22007]: Invalid date value. -->
      <Error Key="InvalidDateValue" Params="1" NativeErrorCode="40500">Invalid date value '%1%'. The year must be in the range [-9999, 9999], the month must be within the range [1, 12], and the day must be within the range [1, 31] while conforming to the range of days for the specified month and year.</Error>

      <!-- [22007]: Invalid time value. -->
      <Error Key="InvalidTimeValue" Params="1" NativeErrorCode="40501">Invalid time value '%1%'. The hour must be in the range [0, 23], the minute must be within the range [0, 59], and the second must be within the range [0, 61] with 60 and 61 being used for leap seconds.</Error>

      <!-- [22007]: Invalid timestamp value. -->
      <Error Key="InvalidTimestampValue" Params="1" NativeErrorCode="40502">Invalid timestamp value '%1%'. The year must be in the range [-9999, 9999] excluding 0, the month must be within the range [1, 12], the day must be within the range [1, 31] while conforming to the range of days for the specified month and year, the hour must be in the range [0, 23], the minute must be within the range [0, 59], and the second must be within the range [0, 61], with 60 and 61 being used for leap seconds.</Error>

      <!-- [22007]: Invalid year to month interval value. -->
      <Error Key="InvalidYearMonthIntervalValue" Params="1" NativeErrorCode="40491">Invalid year to month interval value: %1%. The year must be within the range [0, 999999999], and the month must be within the range [0, 11].</Error>

      <!-- [22007]: Invalid day to hour interval value. -->
      <Error Key="InvalidDayHourIntervalValue" Params="1" NativeErrorCode="40492">Invalid day to hour interval value: %1%. The day must be within the range [0, 999999999], and the hour must be within the range [0, 23].</Error>

      <!-- [22007]: Invalid day to minute interval value. -->
      <Error Key="InvalidDayMinuteIntervalValue" Params="1" NativeErrorCode="40493">Invalid day to minute interval value: %1%. The day must be within the range [0, 999999999], the hour must be within the range [0, 23], and the minute must be within the range [0, 59].</Error>

      <!-- [22007]: Invalid day to second interval value. -->
      <Error Key="InvalidDaySecondIntervalValue" Params="1" NativeErrorCode="40494">Invalid day to second interval value: %1%. The day must be within the range [0, 999999999], and the hour must be within the range [0, 23], and the minute and second must be within the range [0, 59].</Error>

      <!-- [22007]: Invalid hour to minute interval value. -->
      <Error Key="InvalidHourMinuteIntervalValue" Params="1" NativeErrorCode="40495">Invalid hour to minute interval value: %1%. The hour must be within the range [0, 999999999], and the minute must be within the range [0, 59].</Error>

      <!-- [22007]: Invalid hour to second interval value. -->
      <Error Key="InvalidHourSecondIntervalValue" Params="1" NativeErrorCode="40496">Invalid hour to second interval value: %1%. The hour must be within the range [0, 999999999] and the minute and second must be within the range [0, 59].</Error>

      <!-- [22007]: Invalid minute to second interval value. -->
      <Error Key="InvalidMinuteSecondIntervalValue" Params="1" NativeErrorCode="40497">Invalid minute to second interval value: %1%. The minute must be within the range [0, 999999999] and the second must be within the range [0, 59].</Error>

      <!-- [22007]: Invalid second interval value. -->
      <Error Key="InvalidSecondIntervalValue" Params="1" NativeErrorCode="40498">Invalid second interval value: %1%. The second must be within the range [0, 999999999].</Error>

      <!-- [22007]: Invalid single field interval value. -->
      <Error Key="InvalidSingleFieldIntervalValue" Params="1" NativeErrorCode="40499">Invalid single field interval value: %1%. The value must be within the range [0, 999999999].</Error>

      <!-- [22008]: Invalid datetime value resulting in a field overflow. -->
      <Error Key="IntervalArithOverflow" Params="1" NativeErrorCode="40519">Interval field overflow resulted from '%1%' operation.</Error>

      <!-- [22008]: Invalid datetime value resulting in a field overflow. -->
      <Error Key="DatetimeFieldOverflow" NativeErrorCode="40520">Datetime field overflow resulting from invalid datetime.</Error>

      <!-- [22015]: Interval field overflow. -->
      <Error Key="IntervalFieldOverflow" NativeErrorCode="40530">Interval field overflow.</Error>

      <!-- [22015]: Leading precision is too small for the leading interval value. -->
      <Error Key="InvalidLeadingPrecision" NativeErrorCode="40540">Leading precision is smaller than precision of leading interval value.</Error>

      <!-- [22015]: Leading interval precision exceeded. -->
      <Error Key="LeadingPrecisionExceeded" Params="1" NativeErrorCode="40541">Leading interval precision of %1% exceeded.</Error>

      <!-- [22015]: Fractional seconds precision exceeded. -->
      <Error Key="FractionalPrecisionExceeded" Params="1" NativeErrorCode="40542">Fractional seconds precision of %1% exceeded.</Error>

      <!-- [22018]: Invalid character value for cast. -->
      <Error Key="InvalidCharValForCast" NativeErrorCode="40550">Invalid character value for cast specification.</Error>

      <!-- [22018]: Invalid GUID data format. -->
      <Error Key="InvalidGuidValue" Params="1" NativeErrorCode="40560">Invalid GUID data value: %1%. Data should be in the format of XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX with optional enclosing {} braces.</Error>

      <!-- [HY013]: Out of memory error. -->
      <Error Key="OutOfMemoryError" NativeErrorCode="40600">Out of memory error.</Error>
      
      <!-- [HY000]: Conversion invalid data. -->
      <Error Key="ConvInvalidData" NativeErrorCode="40610">Invalid data for conversion.</Error>
      
      <!-- [HY000]: Conversion logic error. -->
      <Error Key="ConvLogicError" NativeErrorCode="40620">Logic error during conversion.</Error>

      <!-- [HY000]: Invalid argument passed to a function. -->
      <Error Key="InvalidArgument" Params="2" NativeErrorCode="30020">Invalid argument(s) passed into a function [%1%: %2%].</Error>

      <!-- [HY000]: Invalid argument passed to a function. -->
      <Error Key="InvalidArgumentParam" Params="3" NativeErrorCode="30021">Invalid argument (%1%) passed into a function [%2%: %3%].</Error>

      <!-- [HY000]: Invalid function/method has been invoked. -->
      <Error Key="InvalidOperation" Params="3" NativeErrorCode="30030">A logic error occurred while calling function %1% [%2%: %3%]. Ensure the operation is supported and the function is implemented.</Error>

      <!-- [HY000]: Semaphore at maximum value. -->
      <Error Key="ErrSemaphoreMaxValue" NativeErrorCode="40621">Cannot set semaphore to a value greater than SEMAPHORE_MAX_VALUE.</Error>

      <!-- [HY000]: Error initializing semaphore. -->
      <Error Key="ErrSemaphoreInit" Params="1" NativeErrorCode="40622">Error initializing semaphore: %1%</Error>

      <!-- Error thrown when there is an I/O error. -->
      <Error Key="IOError" NativeErrorCode="40630">An I/O error has occurred.</Error>

      <!-- Error thrown when registry key not found when trying to connect. --> 
      <Error Key="RegKeyNotFound" NativeErrorCode="50010">Registry key not found.</Error>

      <!-- Error thrown when cannot open registry when trying to connect.  --> 
      <Error Key="CannotOpenRegistry" NativeErrorCode="50020">Cannot open registry.</Error>

      <!-- Error thrown when cannot open ini file when trying to connect. --> 
      <Error Key="CannotOpenIniFile" NativeErrorCode="50040">Cannot open Ini file.</Error>

      <!-- Error thrown when environment variable not found when trying to connect. --> 
      <Error Key="EnvVarNotFound" Params="1" NativeErrorCode="50050">Environment variable not found: '%1%'.</Error>

      <!-- Error thrown when a file cannot be opened. -->
      <Error Key="CannotOpenFile" Params="2" NativeErrorCode="50070">Cannot open file '%1%' - Error: %2%</Error>

      <!-- Error thrown when an encoding type is not recognized. --> 
      <Error Key="EncodingNotRecog" NativeErrorCode="50080">Encoding is not recognized.</Error>

      <!-- Error thrown when conversion from string to numeric value fails. -->
      <Error Key="StrToNumConvFailed" Params="1" NativeErrorCode="50090">Conversion from string to number failed with value: '%1%'</Error>

      <!-- Error thrown when conversion from string to unsigned numeric value fails. -->
      <Error Key="StrToNumConvFailedUnsigned" Params="1" NativeErrorCode="50100">Conversion from string to unsigned number failed with value: '%1%'</Error>

      <!-- Error thrown when conversion from string to numeric value due to overflow fails. -->
      <Error Key="StrToNumConvFailedOverflow" Params="1" NativeErrorCode="50110">Conversion from string to number failed due to overflow with value: '%1%'</Error>

      <!-- Error thrown when conversion from string to numeric value due to underflow fails. -->
      <Error Key="StrToNumConvFailedUnderflow" Params="1" NativeErrorCode="50120">Conversion from string to number failed due to underflow with value: '%1%'</Error>

      <!-- Error thrown when conversion from integer to string value fails due to an undersized buffer. -->
      <Error Key="NumToStrConvFailed" NativeErrorCode="50130">Conversion from number to string failed due to an undersized character buffer.</Error>

      <!-- Error thrown when using a method that has not been implemented yet. --> 
      <Error Key="NotImplYet" NativeErrorCode="50140">Method not implemented yet.</Error>

      <!-- Error thrown when an argument is passed to an object that is invalid. -->
      <Error Key="ThreadInvalidStateAction" NativeErrorCode="50160">Invalid action for thread in current state.</Error>

      <!-- Error thrown when creation of a new thread failed. -->
      <Error Key="ThreadCreationFailed" NativeErrorCode="50170">Creation of new thread failed.</Error>

      <!-- Error thrown when creation of new thread attributes failed. -->
      <Error Key="ThreadAttributeCreationFailed" NativeErrorCode="50175">Creation of new thread attributes failed.</Error>

      <!-- Error thrown when a wait for a thread has failed. -->
      <Error Key="ThreadWaitFailed" NativeErrorCode="50180">Wait for thread failed.</Error>

      <!-- Error thrown when a thread is started multiple times. -->
      <Error Key="ThreadAlreadyStarted" NativeErrorCode="50185">Thread has already been started, cannot be started multiple times.</Error>

      <!-- Error thrown when a temporary file cannot be generated for swapping. -->
      <Error Key="CannotGenerateTempFileName" Params="2" NativeErrorCode="50190">Error creating temporary swap file in directory '%1%' due to error %2%.</Error>

      <!-- Error thrown when a temporary file cannot be generated for swapping. -->
      <Error Key="CannotGenerateTempFileNoError" Params="1" NativeErrorCode="50191">Error creating temporary swap file in directory '%1%'.</Error>

      <!-- Error thrown when name for file is invalid.  -->
      <Error Key="InvalidFileName" NativeErrorCode="50200">File name is invalid.</Error>

      <!-- Error thrown when text file position cannot be set.  -->
      <Error Key="CannotSetFilePosition" NativeErrorCode="50210">Cannot set file position.</Error>

      <!-- Error thrown when the maximum size for code point is invalid (i.e too large). --> 
      <Error Key="InvalidCodePtMaxSize" NativeErrorCode="50220">Invalid maximum size for code point.</Error>

      <!-- Error thrown when there is an invalid number of code points in a buffer (i.e too many). --> 
      <Error Key="InvalidNumCodePtInBuffer" NativeErrorCode="50230">Invalid number of code points in a buffer.</Error>

      <!-- Error thrown when the position in a buffer is invalid (i.e buffer overrun). --> 
      <Error Key="InvalidBuffPos" NativeErrorCode="50240">Invalid buffer position.</Error>

      <!-- Error thrown when output string will not align properly with the output byte buffer. --> 
      <Error Key="StrByteAlignErr" NativeErrorCode="50250">String bytes does not align properly.</Error>

      <!-- Error thrown when the endianness of the encoding is invalid for the platform (i.e. big endian for Windows, or for Unix on a little endian machine). --> 
      <Error Key="InvalidEncodingEndianForPlatform" NativeErrorCode="50260">Invalid encoding endianness for the platform.</Error>

      <!-- Error thrown when trying to set a buffer that hasn't been fully used yet, or when setting it with an invalid buffer. --> 
      <Error Key="SetBuffErr" NativeErrorCode="50270">Setting a buffer that has not been fully used, or setting it with an invalid buffer.</Error>

      <!-- Error thrown when given NULL for a parameter that should not be NULL. --> 
      <Error Key="InvalidNullParam" NativeErrorCode="50280">Parameter cannot be null.</Error>

      <!-- Error thrown when ICU gives an error when creating a Unicode converter object. --> 
      <Error Key="ICUCreateUConverterErr" Params="1" NativeErrorCode="50290">Error creating an ICU Unicode converter object for encoding '%1%'.</Error>

      <!-- Error thrown when ICU gives an error when converting a string. --> 
      <Error Key="ICUConvErr" NativeErrorCode="50300">Error converting a string with ICU.</Error>

      <!-- Error thrown when ICU gives an unrecognized conversion error. --> 
      <Error Key="ICUConvErrNotRecog" NativeErrorCode="50310">Unrecognized ICU conversion error.</Error>

      <!-- Error thrown when ICU gives an error using a regex. --> 
      <Error Key="ICURegexError" Params="1" NativeErrorCode="50315">Error using regular expression: %1%.</Error>

      <!-- Error thrown when an unsupported code unit size is specified when retrieving data. --> 
      <Error Key="UnsupportedCodeUnitSize" Params="1" NativeErrorCode="50320">Unsupported code unit size (%1%) for data retrieval.</Error>

      <!-- Product License Errors and Warnings -->

      <!-- Error thrown when license file is not found. -->
      <Error Key="LicFileNotFound" Params="1" NativeErrorCode="50325">The license file '%1%' could not be found. Please contact your administrator or Simba Technologies Inc. at sales@simba.com.</Error>

      <!-- Error thrown when license file is corrupt. -->
      <Error Key="LicFileCorrupt" Params="1" NativeErrorCode="50330">The license file '%1%' is corrupt. Please contact your administrator or Simba Technologies Inc. at sales@simba.com.</Error>

      <!-- Error thrown when evaluation is expired. -->
      <Error Key="TrialPeriodExp" Params="1" NativeErrorCode="50340">Your license expired on %1%. Please contact Simba Technologies Inc. at sales@simba.com.</Error>
      
      <!-- Error thrown when evaluation has not yet begun. -->
      <Error Key="TrialPeriodNotBegun" Params="1" NativeErrorCode="50341">Your evaluation period has not yet started, it will start on %1%. Please contact Simba Technologies Inc. at sales@simba.com.</Error>

      <!-- Warning posted when evaluation will expire soon. -->
      <Error Key="TrialPeriodExpSoon" Params="1" NativeErrorCode="50342">Your evaluation period will expire on %1%. Please contact Simba Technologies Inc. at sales@simba.com.</Error>

      <!-- Error thrown when an INI file contains a line that cannot be parsed. -->
      <Error Key="IniParseError" Params="2" NativeErrorCode="50350">INI Parse error on line %1% of %2%.</Error>

      <!-- Error thrown when the license check fails. -->
      <Error Key="LicenseValidationFailure" Params="1" NativeErrorCode="50351">License validation error: %1%. Please contact Simba Technologies Inc. at sales@simba.com.</Error>
      
      <!-- Authentication failed for integrated security. -->
      <Error Key="IntegratedSecurityAuthFailed" NativeErrorCode="50360" Params="1">Integrated security authentication failed. (%1%)</Error>

      <!-- Integrated security failed to acquire local credentials. -->
      <Error Key="FailedToAcquireCredentials" NativeErrorCode="50361" Params="1">Integrated security failed to acquire local credentials. (%1%)</Error>

      <!-- Error thrown on failure to get username for integrated security. -->
      <Error Key="FailedToGetUsername" NativeErrorCode="50363" Params="1">Failed to get username. (%1%)</Error>

      <!-- Error thrown if attempting to change properties of a security context already in progress. -->
      <Error Key="SecurityContextInProgress" NativeErrorCode="50364">Cannot change properties of the security context because it is already in progress.</Error>

      <!-- Error thrown if there is a failure establishing thread impersonation -->
      <Error Key="ThreadImpersonationFailed" NativeErrorCode="50365" Params="1">Error enabling thread impersonation. (%1%)</Error>

      <!-- Error thown when gssapi lib delay load fails. -->
      <Error Key="GSSAPILoadFailed" NativeErrorCode="50366" Params="1">Failed to load the security library: (%1%)</Error>
      
      <!-- Error thown when attempting to use the security API on an unsupported platform. -->
      <Error Key="NoSecurityAPI" NativeErrorCode="50367" Params="0">No supported security API on this platform. </Error>
      <!-- Error thown when an invalid TDWExactNumericType is detected. -->
      <Error Key="InvalidNumeric" NativeErrorCode="50368" Params="0">Validation of TDWExactNumericType object failed.</Error>

      <!-- Error thrown when OpenSSL fails to load. -->
      <Error Key="LibLoadErr" Params="2" NativeErrorCode="50400">There was an error while loading the dynamic or shared library '%1%': '%2%'.</Error>
	  
      <!-- Error thrown when OpenSSL fails to load. -->
      <Error Key="LibFunctLoadErr" Params="2" NativeErrorCode="50401">There was an error while loading the function '%2%' from the dynamic or shared library '%1%'.</Error>
	  
      <!-- Error thrown when OpenSSL fails to load. -->
      <Error Key="SwapFileEncryptErr"  Params="2" NativeErrorCode="50402">There was an internal error while encrypting or decrypting the content of a swap file: Call '%1%' - reason '%2%'.</Error>
	  
      <!-- Error thrown when the total swap file disk space has reached the limit. -->
      <Error Key="SwapLimitErr" NativeErrorCode="50403">Total swap files disk space limit reached.</Error>
	  
    </Package>
</Messages>
